
public class AssessmentPartThree 
{

	// The simplest form of encryption is the rotation cipher (also known as Caeser's Cipher)
	// An offset value is chosen to encrypt a message. Each letter is replaced by the
	// letter that that number of places away from it.
	// So if an offset value of 1 is chosen, each letter is replaced by the one after it
	// - so a becomes b, b becomes c, etc
	// If a value of -2 is chosen a becomes y, b becomes z and so on
	
	public char enryptedCharacter(char theChar, int theOffset)
	{
	// 05 - encryptedCharacter
	// Complete this method so that it returns the encrypted character for
	// theChar when and offset of theOffset is used
	// So if theChar='m' and theOffset is 3 the method will return 'p'
	// Lower case characters remain lower case, upper case remain upper case
	// Any other characters are returned unchanged
	  
		//Dealing with negative offsets
		theOffset = (theOffset < 0) ? 26 + theOffset : theOffset;
		//ensures that the offset will "wrap around"
		
		//Uppercase characters
		if((theChar >= 65) && (theChar <= 90)) //65 to 90 = A to B
		{
			theChar = (char) (((theChar - 65 + theOffset) % 26) + 65);
		}
		//Lowercase characters
		else if((theChar >= 97) && (theChar <= 122)) // 97 to 122 = a to b
		{
			theChar = (char) (((theChar - 97 + theOffset) % 26) + 97);
		}
		/*
			theChar = (char) (((theChar - 97 + theOffset) % 26) + 97);		formulae
		                       (theChar - 97 								- ASCII a/A to give value between 1 and 26  
								             + theOffset)					+ the offset value
		                      (                           % 26)				% modulo ensures value is always between 1 and 26
		                     (                                  + 97)		+ ASCII a/A to return result to ASCII char
		              (char) 												result needs to be casted to char 
		*/
		
		return theChar;
		//any non alphabetical chars will fall through and return original char
	}

	 
	public String encryptedString(String theMessage, int theOffset)
	{
	// 06 - encryptedMessage
	// Complete this method so that it uses encryptedCharacter to 
	// return the encrypted version of theMessage using theOffset
	 
		char chaMessageArr[] = theMessage.toCharArray();
		char[] chaResultArr = new char[chaMessageArr.length];
	//initialising Arrays
	  
	for(int i = 0; i < chaMessageArr.length; i++)
	//loop to run through each character in encrypted message
	{
		 chaResultArr[i] = enryptedCharacter(chaMessageArr[i], theOffset);
		 //passing each character to decryption method and saving result in array
	}
	 
	return (new String(chaResultArr));
	//converting result array into string, and returning this
	}
	
}
